Index: /main/waeup.aaue/trunk/src/waeup/aaue/locales/en/LC_MESSAGES/waeup.kofa.po
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/locales/en/LC_MESSAGES/waeup.kofa.po	(revision 13865)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/locales/en/LC_MESSAGES/waeup.kofa.po	(revision 13866)
@@ -13,5 +13,5 @@
 
 msgid "Term"
-msgstr "Sem."
+msgstr "Semester"
 
 #: waeup/kofa/students/browser.py:1013
Index: /main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 13865)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 13866)
@@ -246,9 +246,9 @@
         elif self.context.student.current_mode.endswith('_pt'):
             line0 = 'DIRECTORATE OF PART-TIME DEGREE PROGRAMMES\n'
-        line1 = translate('Course Registration Slip',
-            'waeup.kofa', target_language=portal_language) \
+        line1 = translate(_('Course Registration Slip'),
+            target_language=portal_language) \
             + ' %s' % level_title
-        line2 = translate('Session',
-            'waeup.kofa', target_language=portal_language) \
+        line2 = translate(_('Session'),
+            target_language=portal_language) \
             + ' %s' % self.context.getSessionString
         return '%s%s\n%s' % (line0, line1, line2)
@@ -257,6 +257,5 @@
     def title(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate('Units Registered', 'waeup.kofa',
-            target_language=portal_language)
+        return translate(_('Units Registered'), target_language=portal_language)
 
     def _signatures(self):
@@ -296,12 +295,12 @@
     def render(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        Sem = translate('Sem.', 'waeup.kofa', target_language=portal_language)
-        Code = translate('Code', 'waeup.kofa', target_language=portal_language)
-        Title = translate('Title', 'waeup.kofa', target_language=portal_language)
-        Cred = translate('Cred.', 'waeup.kofa', target_language=portal_language)
-        Score = translate('Score', 'waeup.kofa', target_language=portal_language)
-        CA = translate('CA', 'waeup.kofa', target_language=portal_language)
-        Grade = translate('Grade', 'waeup.kofa', target_language=portal_language)
-        Signature = translate('Lecturer\'s Signature', 'waeup.aaue',
+        Sem = translate(_('Sem.'), target_language=portal_language)
+        Code = translate(_('Code'), target_language=portal_language)
+        Title = translate(_('Title'), target_language=portal_language)
+        Cred = translate(_('Cred.'), target_language=portal_language)
+        Score = translate(_('Score'), target_language=portal_language)
+        CA = translate(_('CA'), target_language=portal_language)
+        Grade = translate(_('Grade'), target_language=portal_language)
+        Signature = translate(_('Lecturer\'s Signature'), 'waeup.aaue',
             target_language=portal_language)
         studentview = StudentBasePDFFormPage(self.context.student,
@@ -354,11 +353,11 @@
     def render(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        Term = translate('Term', 'waeup.kofa', target_language=portal_language)
-        Code = translate('Code', 'waeup.kofa', target_language=portal_language)
-        Title = translate('Title', 'waeup.kofa', target_language=portal_language)
-        Cred = translate('Credits', 'waeup.kofa', target_language=portal_language)
-        Score = translate('Score', 'waeup.kofa', target_language=portal_language)
-        #CA = translate('CA', 'waeup.kofa', target_language=portal_language)
-        Grade = translate('Grade', 'waeup.kofa', target_language=portal_language)
+        Term = translate(_('Sem.'), target_language=portal_language)
+        Code = translate(_('Code'), target_language=portal_language)
+        Title = translate(_('Title'), target_language=portal_language)
+        Cred = translate(_('Credits'), target_language=portal_language)
+        Score = translate(_('Score'), target_language=portal_language)
+        #CA = translate(_('CA'), target_language=portal_language)
+        Grade = translate(_('Grade'), target_language=portal_language)
         studentview = StudentBasePDFFormPage(self.context.student,
             self.request, self.omit_fields)
@@ -390,6 +389,6 @@
     def label(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate('e-Admission Slip \n',
-            'waeup.kofa', target_language=portal_language) \
+        return translate(_('e-Admission Slip \n'),
+            target_language=portal_language) \
             + ' %s' % self.context.display_fullname
 
@@ -401,6 +400,6 @@
     def label(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate('Clearance Slip\n',
-            'waeup.kofa', target_language=portal_language) \
+        return translate(_('Clearance Slip\n'),
+            target_language=portal_language) \
             + ' %s' % self.context.display_fullname
 
@@ -441,5 +440,5 @@
     def title(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate('Matriculation Number', 'waeup.kofa',
+        return translate(_('Matriculation Number'), 'waeup.kofa',
             target_language=portal_language)
 
@@ -447,6 +446,6 @@
     def label(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate('Matriculation Number Slip\n',
-            'waeup.kofa', target_language=portal_language) \
+        return translate(_('Matriculation Number Slip\n'),
+            target_language=portal_language) \
             + ' %s' % self.context.display_fullname
 
@@ -481,5 +480,5 @@
     def title(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate('Personal Data', 'waeup.kofa',
+        return translate(_('Personal Data'), 'waeup.kofa',
             target_language=portal_language)
 
@@ -487,6 +486,6 @@
     def label(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate('Personal Data Slip\n',
-            'waeup.kofa', target_language=portal_language) \
+        return translate(_('Personal Data Slip\n'),
+            target_language=portal_language) \
             + ' %s' % self.context.display_fullname
 