Index: main/waeup.kofa/branches/uli-scores-upload/src/waeup/kofa/students/browser.py
===================================================================
--- main/waeup.kofa/branches/uli-scores-upload/src/waeup/kofa/students/browser.py	(revision 13921)
+++ main/waeup.kofa/branches/uli-scores-upload/src/waeup/kofa/students/browser.py	(revision 13922)
@@ -3130,8 +3130,4 @@
             scores = form['scores']
             sids = form['sids']
-            if isinstance(scores, basestring):
-                scores = [scores]
-            if isinstance(sids, basestring):
-                sids = [sids]
             formvals = dict([(sids[i], scores[i]) for i in range(len(sids))])
             for ticket in editable_tickets:
Index: main/waeup.kofa/branches/uli-scores-upload/src/waeup/kofa/students/browser_templates/editscorespage.pt
===================================================================
--- main/waeup.kofa/branches/uli-scores-upload/src/waeup/kofa/students/browser_templates/editscorespage.pt	(revision 13921)
+++ main/waeup.kofa/branches/uli-scores-upload/src/waeup/kofa/students/browser_templates/editscorespage.pt	(revision 13922)
@@ -24,7 +24,7 @@
 
   	  <td tal:condition="ticket/editable_by_lecturer" style="width: 65px;">
-          <input type="text" name="scores" class="form-control"
+          <input type="text" name="scores:list" class="form-control"
   	             tal:attributes="value ticket/score" />
-          <input type="hidden" name="sids"
+          <input type="hidden" name="sids:list"
                  tal:attributes="value ticket/student/student_id" />
       </td>
Index: main/waeup.kofa/branches/uli-scores-upload/src/waeup/kofa/students/tests/test_browser.py
===================================================================
--- main/waeup.kofa/branches/uli-scores-upload/src/waeup/kofa/students/tests/test_browser.py	(revision 13921)
+++ main/waeup.kofa/branches/uli-scores-upload/src/waeup/kofa/students/tests/test_browser.py	(revision 13922)
@@ -3962,5 +3962,6 @@
         IWorkflowState(self.student).setState(VALIDATED)
         self.browser.open(self.edit_scores_url)
-        self.assertTrue(self.browser.getControl(name="scores") is not None)
+        self.assertTrue(
+            self.browser.getControl(name="scores:list") is not None)
 
     def test_score_editing_offers_only_current_scores(self):
@@ -3981,5 +3982,6 @@
         self.app['configuration'].current_academic_session = 2004
         self.browser.reload()
-        self.assertTrue(self.browser.getControl(name="scores") is not None)
+        self.assertTrue(
+            self.browser.getControl(name="scores:list") is not None)
 
     def test_score_editing_can_change_scores(self):
@@ -3989,5 +3991,5 @@
             self.student['studycourse']['100']['COURSE1'].score, None)
         self.browser.open(self.edit_scores_url)
-        self.browser.getControl(name="scores", index=0).value = '55'
+        self.browser.getControl(name="scores:list", index=0).value = '55'
         self.browser.getControl("Update scores").click()
         # the new value is stored in data
@@ -3996,5 +3998,5 @@
         # the new value is displayed on page/prefilled in form
         self.assertEqual(
-            self.browser.getControl(name="scores", index=0).value, '55')
+            self.browser.getControl(name="scores:list", index=0).value, '55')
         # The change has been logged
         with open(self.stud_log_path, 'r') as fd:
@@ -4007,5 +4009,5 @@
         self.login_as_lecturer()
         self.browser.open(self.edit_scores_url)
-        self.browser.getControl(name="scores", index=0).value = 'abc'
+        self.browser.getControl(name="scores:list", index=0).value = 'abc'
         self.browser.getControl("Update scores").click()
         self.assertTrue(
@@ -4019,5 +4021,5 @@
         self.student['studycourse']['100']['COURSE1'].score = None
         self.browser.open(self.edit_scores_url)
-        self.browser.getControl(name="scores", index=0).value = ''
+        self.browser.getControl(name="scores:list", index=0).value = ''
         self.browser.getControl("Update scores").click()
         logcontent = open(self.stud_log_path, 'r').read()
@@ -4025,5 +4027,5 @@
         # now retry with some value set
         self.student['studycourse']['100']['COURSE1'].score = 55
-        self.browser.getControl(name="scores", index=0).value = ''
+        self.browser.getControl(name="scores:list", index=0).value = ''
         self.browser.getControl("Update scores").click()
         logcontent = open(self.stud_log_path, 'r').read()