Index: main/waeup.kofa/branches/uli-scores-upload/src/waeup/kofa/students/browser.py
===================================================================
--- main/waeup.kofa/branches/uli-scores-upload/src/waeup/kofa/students/browser.py	(revision 13927)
+++ main/waeup.kofa/branches/uli-scores-upload/src/waeup/kofa/students/browser.py	(revision 13928)
@@ -19,29 +19,29 @@
 """
 import csv
-import sys
 import grok
 import pytz
+import sys
 from cStringIO import StringIO
+from datetime import datetime
+from hurry.workflow.interfaces import IWorkflowInfo, IWorkflowState
 from urllib import urlencode
-from datetime import datetime
-from zope.event import notify
-from zope.i18n import translate
 from zope.catalog.interfaces import ICatalog
 from zope.component import queryUtility, getUtility, createObject
+from zope.event import notify
+from zope.formlib.textwidgets import BytesDisplayWidget
+from zope.i18n import translate
 from zope.schema.interfaces import ConstraintNotSatisfied, RequiredMissing
-from zope.formlib.textwidgets import BytesDisplayWidget
 from zope.security import checkPermission
-from hurry.workflow.interfaces import IWorkflowInfo, IWorkflowState
 from waeup.kofa.accesscodes import (
     invalidate_accesscode, get_access_code)
 from waeup.kofa.accesscodes.workflow import USED
+from waeup.kofa.browser.breadcrumbs import Breadcrumb
+from waeup.kofa.browser.interfaces import ICaptchaManager
 from waeup.kofa.browser.layout import (
     KofaPage, KofaEditFormPage, KofaAddFormPage, KofaDisplayFormPage,
     NullValidator, jsaction, action, UtilityView)
-from waeup.kofa.browser.breadcrumbs import Breadcrumb
 from waeup.kofa.browser.pages import (
     ContactAdminFormPage, ExportCSVView, doll_up, exports_not_allowed,
     LocalRoleAssignmentUtilityView)
-from waeup.kofa.browser.interfaces import ICaptchaManager
 from waeup.kofa.hostels.hostel import NOT_OCCUPIED
 from waeup.kofa.interfaces import (
@@ -50,14 +50,14 @@
     academic_sessions_vocab, IDataCenter, DOCLINK)
 from waeup.kofa.interfaces import MessageFactory as _
-from waeup.kofa.widgets.datewidget import FriendlyDatetimeDisplayWidget
 from waeup.kofa.mandates.mandate import PasswordMandate
 from waeup.kofa.university.interfaces import (
     IDepartment, ICertificate, ICourse)
+from waeup.kofa.university.certificate import (
+    VirtualCertificateExportJobContainer)
+from waeup.kofa.university.department import (
+    VirtualDepartmentExportJobContainer)
 from waeup.kofa.university.faculty import VirtualFacultyExportJobContainer
-from waeup.kofa.university.department import VirtualDepartmentExportJobContainer
 from waeup.kofa.university.facultiescontainer import (
     VirtualFacultiesExportJobContainer)
-from waeup.kofa.university.certificate import (
-    VirtualCertificateExportJobContainer,)
 from waeup.kofa.university.course import (
     VirtualCourseExportJobContainer,)
@@ -65,17 +65,16 @@
 from waeup.kofa.utils.batching import VirtualExportJobContainer
 from waeup.kofa.utils.helpers import get_current_principal, now
+from waeup.kofa.widgets.datewidget import FriendlyDatetimeDisplayWidget
 from waeup.kofa.students.interfaces import (
-    IStudentsContainer, IStudent,
-    IUGStudentClearance,IPGStudentClearance,
+    IStudentsContainer, IStudent, IUGStudentClearance, IPGStudentClearance,
     IStudentPersonal, IStudentPersonalEdit, IStudentBase, IStudentStudyCourse,
     IStudentStudyCourseTransfer, IStudentStudyCourseTranscript,
-    IStudentAccommodation, IStudentStudyLevel,
-    ICourseTicket, ICourseTicketAdd, IStudentPaymentsContainer,
-    IStudentOnlinePayment, IStudentPreviousPayment, IStudentBalancePayment,
-    IBedTicket, IStudentsUtils, IStudentRequestPW, IStudentTranscript
+    IStudentAccommodation, IStudentStudyLevel, ICourseTicket, ICourseTicketAdd,
+    IStudentPaymentsContainer, IStudentOnlinePayment, IStudentPreviousPayment,
+    IStudentBalancePayment, IBedTicket, IStudentsUtils, IStudentRequestPW,
+    IStudentTranscript
     )
 from waeup.kofa.students.catalog import search, StudentQueryResultItem
 from waeup.kofa.students.vocabularies import StudyLevelSource
-
 from waeup.kofa.students.workflow import (
     ADMITTED, PAID, CLEARANCE, REQUESTED, RETURNING, CLEARED, REGISTERED,
@@ -84,5 +83,6 @@
 
 
-grok.context(IKofaObject) # Make IKofaObject the default context
+grok.context(IKofaObject)  # Make IKofaObject the default context
+
 
 # Save function used for save methods in pages
@@ -91,5 +91,5 @@
     # Turn list of lists into single list
     if changed_fields:
-        changed_fields = reduce(lambda x,y: x+y, changed_fields.values())
+        changed_fields = reduce(lambda x, y: x+y, changed_fields.values())
     # Inform catalog if certificate has changed
     # (applyData does this only for the context)